<template>
  <button
      :class="{'btn-rounded': isCapsule, 'btn-rounded button-shadow': isCapsuleShadow,
       'button-shadow': isRectangleShadow, 'branching-width': fullWidth, 'btn-transition': !fullWidth}"
      :style="getButtonStyleObject()"
      class="btn" type="button"
      @click="onBtnClick"
  >
    {{ text }}
  </button>
</template>

<script>

module.exports = {
  props: ['data', 'onBtnClick', 'text', 'fullWidth', 'customStyle'],
  computed: {
    isCapsule() {
      return (this.data['button-style']).toLowerCase() === 'capsule'
    },
    isCapsuleShadow() {
      return (this.data['button-style']).toLowerCase() === 'capsule-shadow'
    },
    isRectangle() {
      return (this.data['button-style']).toLowerCase() === 'rectangle'
    },
    isRectangleShadow() {
      return (this.data['button-style']).toLowerCase() === 'rectangle-shadow'
    }
  },
  methods: {
    getButtonStyleObject() {
      return Object.assign({}, this.data['button-font-StyleObj'], this.data.btnColorObj, this.customStyle)
    }
  }
}
</script>
<style>

.btn-transition {
  -webkit-transition-duration: .2s;
  transition-duration: .2s;
  -webkit-transition-property: all !important;
  transition-property: all !important;
  padding: 0.8rem 2rem !important;
}

.btn-transition:hover {
  transition: padding 300ms ease 0ms;
  padding: 1rem 2.3rem !important;
  /*box-shadow: 0px 0px 10px 0px #4b1ed2;*/
}

button {
  border: none !important;
  outline: none !important;
  white-space: nowrap !important;
}

button:focus {
  outline: none !important;
}

.button-shadow {
  box-shadow: rgba(0, 0, 0, 0.16) 0px 3px 6px, rgba(0, 0, 0, 0.33) 0px 5px 6px !important;
}

.branching-width {
  -webkit-transition-duration: .2s;
  transition-duration: .2s;
  -webkit-transition-property: all !important;
  transition-property: all !important;
  padding: 0.55rem 2.5rem !important;
  min-width: 90% !important;
}

.branching-width:hover {
  transition: padding 300ms ease 0ms;
  padding: 0.8rem 14rem !important;
  /*box-shadow: 0px 0px 10px 0px #4b1ed2;*/
}

.btn-rounded {
  border-radius: 10rem !important;
}

</style>
